unit SampleSG;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, DBGrids, DB, DBTables, Buttons;

type
  TSampleSGf = class(TForm)
    DataSource1: TDataSource;
    tCustomer: TTable;
    DBGrid1: TDBGrid;
    StringGrid1: TStringGrid;
    btOk: TButton;
    btCancel: TButton;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SampleSGf: TSampleSGf;

implementation

uses SampleS;

{$R *.DFM}

procedure TSampleSGf.FormCreate(Sender: TObject);

  procedure SetGridSize;
  begin
    StringGrid1.ColCount := DBGrid1.Columns.Count;
    StringGrid1.RowCount := tCustomer.RecordCount;
  end;

  procedure SetGridWidths;
  var x: integer;
  begin
    with DBGrid1.Columns do begin
      for x:=0 to Count-1 do begin
        StringGrid1.ColWidths[x] := Items[x].Width;
      end;
    end;
  end;

  procedure CopyGridCells(y: integer);
  var x: integer;
  begin
    with DBGrid1.Columns do begin
      for x:=0 to Count-1 do begin
        StringGrid1.Cells[x,y] := Items[x].Field.asString;
      end;
    end;
  end;

var
  y: integer;
begin
  SetGridSize;
  SetGridWidths;
  with tCustomer do begin
    First;
    y := 0;
    while not(EOF) do begin
      CopyGridCells(y);
      y := y + 1;
      Next;
    end;
  end;
end;

procedure TSampleSGf.Button1Click(Sender: TObject);
begin
  SampleSf.HyperReport1.Preview;
end;

end.
